// ======================================================================
//
// AAI LOGIN WITH SHIBBOLETH HANDLING MULTIPLE ORGANIZATIONS
// 
// javascript functions for mode = "boxes"
//
// License: GNU GPL 3.0
// Source: https://git-repo.iml.unibe.ch/iml-open-source/login-aai
// ======================================================================


// ----------------------------------------------------------------------
// VARS
// ----------------------------------------------------------------------

var oFilter = document.getElementById('filterbox');
var sLsvar = 'aailogin-q';


// ----------------------------------------------------------------------
// FUNCTIONS
// ----------------------------------------------------------------------

/**
 * Apply filter and reduce listed Idps
 */
function applyfilter() {

    if (oFilter) {
        var q = document.getElementById('filter').value;
        var aQ = q.split(" ");

        // reduce boxes based on filter using AND condition
        for (var i = 0; i < document.getElementsByClassName('idp').length; i++) {
            var idp = document.getElementsByClassName('idp')[i];

            var bShow = true;
            if (q != "") {
                var sText = idp.innerHTML.replace(/<[^>]*>/g, "");
                for (var iPart = 0; iPart < aQ.length; iPart++) {
                    var qPart = aQ[iPart];
                    bShow = bShow & sText.toLowerCase().indexOf(qPart.toLowerCase()) >= 0;

                }
            }
            idp.className = bShow ? 'idp' : 'idp hide';
            document.getElementById('resetfilter').style.display = (q > "") ? 'inline' : 'none';
        }

        var aBtns = document.getElementsByClassName('filterbutton');
        for (var i = 0; i < aBtns.length; i++) {
            var bMarked = false;
            for (var iPart = 0; iPart < aQ.length; iPart++) {
                var qPart = aQ[iPart];
                var id2search = 'filterbtn-dot-' + qPart.replace(/^./, '');
                var qPart = aQ[iPart];
                if(aBtns[i].id == id2search){
                    bMarked = true;
                    break;
                }
            }
            aBtns[i].className = bMarked ? 'filterbutton active' : 'filterbutton';
        }

        document.getElementById('filter').focus();
        localStorage.setItem(sLsvar, q);
    };
}

/**
 * Set a new filter value or reset it
 * @param {string} sNewFiltervalue New value to write into the filter field
 */
function setFilter(sNewFiltervalue) {
    document.getElementById('filter').value = sNewFiltervalue;
    applyfilter();
}

/**
 * Reset the filter and show all Items
 */
function resetFilter() {
    setFilter("");
}
/**
 * Enable filter box if static_link is in use
 * It renders an input field, reads the last search value from local storage 
 * and apllies this filter
 */
function showFilterBox() {
    if (oFilter) {
        var q = localStorage.getItem(sLsvar);
        if (!q) {
            q = '';
        }


        oFilter.style.display = 'block';

        oFilter.innerHTML = '<input type="text" id="filter" placeholder="" onchange="applyfilter()" onkeydown="applyfilter()" onkeyup="applyfilter()" value=""/>'
            + '<a id="resetfilter" onclick="resetFilter(); return false;"> X </a><br>'
            ;
        setFilter(q);

        for (var i = 0; i < document.getElementsByClassName('idp').length; i++) {
            var idp = document.getElementsByClassName('idp')[i];
            idp.setAttribute("onclick", "localStorage.setItem(sLsvar,this.innerText);");
        }
    };
};

// ----------------------------------------------------------------------
// INIT
// ----------------------------------------------------------------------

showFilterBox();

// ----------------------------------------------------------------------
